// compile:   g++ -Wall    FunctionOverloading-CPP.cpp -o FunctionOverloading-CPP
// assembler: g++ -Wall -S FunctionOverloading-CPP.cpp -o FunctionOverloading-CPP.s
// symbols (as is):     nm    FunctionOverloading-CPP
// symbols (demangled): nm -C FunctionOverloading-CPP

// Questions
//  -Is there any runtime cost associated with this?
//  -How are ambiguous function calls resolved (i.e., "square(1)")?
//  -What if only the return type differs?

#include <iostream>

double square(double x) {
  return x*x;
}

float square(float x) {
  return x*x;
}


int main() {
  float  num1;
  double num2;

  std::cin >> num1 
           >> num2;

  square(1);

  num1 = square(num1);
  num2 = square(num2);

  std::cout << num1 << std::endl
            << num2 << std::endl;

  return 0;
}
